#!/bin/sh
#
# @(#)install.sh.m4 1.3 99/01/25 FX
#
# Installed System software for Fuji Xerox Laser Printer.
#
copyright="Copyright(C) 2005 by Fuji Xerox Asia Pacific Pte Ltd. All rights reserved."
progtitle="FXAP UNIX Driver Installer for HP-UX (PA-RISC)"
progname="$0"

PATH=/usr/ucb:/bin:/etc:/usr/bin:/usr/etc:/usr/sbin:/usr/lib


# Setup default parameters

## mono Series
PACKAGE="uxdriver.tar"
BINDIR="/usr/local/fxbin"

## DocuPrint 205 Series
PACKAGE205="uxdriver2.tar"
BINDIR205="/usr/local/fxbin205"

## DocuPrint 240A Series
PACKAGE240A="uxdriver3.tar"
BINDIR240A="/usr/local/fxbin240A"

MANDIR="/usr/man"
CURDIR=`pwd`
CHANGE_EXEC="change"
samples2100="sample.tar"

### names ###
### Utilitys ###
EXEC_OTHERS="euc2ps2 xwd2ps2 tiff2ps2 ufptool"
EXEC_240A="txt2ps2 xwd2ps2 tiff2ps2"

### Manuals ###
MAN="euc2ps2.1 xwd2ps2.1 xwd2g4.1 tiff2ps2.1 tiff2g4.1"
MAN205="euc2ps2205.1 xwd2ps2205.1 xwd2g4205.1 tiff2ps2205.1 tiff2g4205.1"
MAN240A="txt2ps2240A.1 xwd2ps2240A.1 tiff2ps2240A.1"

### Interfaces ###
IFFILE="interfaceDC250 interfaceDC451 interfaceDC506 interfaceDC235" 

INTERZ="change.Z \
    interfaceDC250.Z interfaceDC451.Z interfaceDC506.Z interfaceDC235.Z"

IFFILE205="interfaceDP205 \
    interfaceDC186 interfaceDC286 interfaceDC1100\
    interfaceDC336 interfaceDC550I interfaceDC750I \
    interfaceAP24000 interfaceDC24000 interfaceAP27000 interfaceDC27000 \
    interfaceAP550I interfaceAP750I interfaceDC23005"

INTERZ205="change.Z \
    interfaceDP205.Z \
    interfaceDC186.Z interfaceDC286.Z interfaceDC1100.Z \
    interfaceDC336.Z interfaceDC550I.Z interfaceDC750I.Z \
    interfaceAP24000.Z interfaceDC24000.Z interfaceAP27000.Z interfaceDC27000.Z \
    interfaceAP550I.Z interfaceAP750I.Z interfaceDC23005.Z"

## DocuPrint 240A Series
INTERZ240A="change.Z interface240A.Z"
IFFILE240A="interface240A"

### utility for installation ###

################################
## Printer Model Registration ##
################################
RegisterPrinterModels() {
    Model DC250     interfaceDC250      "Document Centre 250/350/400"
    Model DC451     interfaceDC451      "Document Centre 451/551"
    Model DC506     interfaceDC506      "Document Centre 506/606/706"
    Model DC235     interfaceDC235      "Document Centre 235/285/405"
    Model DP205     interfaceDP205      "DocuPrint 205/255/305"
    Model DP240A    interface240A       "DocuPrint 240A/340A"
    Model DC186     interfaceDC186      "Document Centre 1085/1055/186/156"
    Model DC286     interfaceDC286      "Document Centre 286/236"
    Model DC1100    interfaceDC1100     "Document Centre 1100/900"
    Model DC336     interfaceDC336      "Document Centre 336"
    Model AP550I    interfaceAP550I     "ApeosPort 550 I/450 I/350 I"
    Model DC550I    interfaceDC550I     "DocuCentre 550 I/450 I"
    Model AP750I    interfaceAP750I     "ApeosPort 750 I/650 I/550 I"
    Model DC750I    interfaceDC750I     "DocuCentre 750 I/650 I/550 I"
    Model AP24000   interfaceAP24000    "ApeosPort-II 5010/4000/3000"
    Model DC24000   interfaceDC24000    "DocuCentre-II 5010/4000"
    Model AP27000   interfaceAP27000    "ApeosPort-II 7000/6000"
    Model DC27000   interfaceDC27000    "DocuCentre-II 7000/6000"
    Model DC23005   interfaceDC23005    "DocuCentre-II 3005/2055/2005"
    Model BinaryInstall205  dummy205    "Binary update only"
} #EndRegisterPrinterModels
# model_pt<n> ... printer model name
# model_fd<n> ... Solaris FD file name
# model_mn<n> ... menu string
Model() {
    [ x"$ModelCount" = x ] && ModelCount=0
    eval ModelCount=`expr $ModelCount + 1`
    eval model_pt$ModelCount=$1
    eval model_fd$ModelCount=$2
    eval model_mn$ModelCount="\"$3\""
    eval fd_$1=$2
}

## Display Model Selet Menu
ModelSelectMenu() {
    echo "Please wait..."
    RegisterPrinterModels
    clear
    echo "$progtitle" ;echo "$copyright" ;echo ""
    echo "Printer Model?"
    i=1; tmp=$i; menustr=x
    while [ x"$menustr" != xExit ]; do
        eval menustr="\"\$model_mn$i\""
        [ $i -gt $ModelCount ] && menustr="Exit"
        echo " ${i}. $menustr"
        [ $i -gt 1 ] && tmp="${tmp}/${i}"
        i=`expr $i + 1`
    done
    i=""; while [ "`expr $i + 0 2>&1`" != "$i" ]; do
        echo "Enter Process No(${tmp})?:\c"
        read i
    done
    if [ $i -gt $ModelCount ]; then
        exit;
    fi
        eval INTERFACE=\$model_fd$i
    eval PrinterName=\$model_pt$i
    if [ "`P205check`" = "true" ]
    then
        PACKAGE=$PACKAGE205
        BINDIR=$BINDIR205
        MAN=$MAN205
        IFFILE=$IFFILE205
        INTERZ=$INTERZ205
    fi

    if [ "`P240Acheck`" = "true" ]
    then
        PACKAGE=$PACKAGE240A
        BINDIR=$BINDIR240A
        MAN=$MAN240A
        IFFILE=$IFFILE240A
        INTERZ=$INTERZ240A
    fi
}

### mono205 Series Check ###
P205check() {
    if [ "${PrinterName}" = "DP205" ]
    then
        echo "true"     # DocuPrint 205 Series
    elif [ "${PrinterName}" = "DC186" ]
    then
        echo "true"     # Document Centre 1085/1055/186/156 Series
    elif [ "${PrinterName}" = "DC286" ]
    then
        echo "true"     # Document Centre 286/236 Series
    elif [ "${PrinterName}" = "DC1100" ]
    then
        echo "true"     # Document Centre 1100/900 Series
    elif [ "${PrinterName}" = "DC336" ]
    then
        echo "true"     # Document Centre 336 Series
    elif [ "${PrinterName}" = "AP550I" ]
    then
        echo "true"     # ApeosPort 550 I/450 I/350 I Series
    elif [ "${PrinterName}" = "DC550I" ]
    then
        echo "true"     # DocuCentre 550 I/450 I Series
    elif [ "${PrinterName}" = "AP750I" ]
    then
        echo "true"     # ApeosPort 750 I/650 I Series
    elif [ "${PrinterName}" = "DC750I" ]
    then
        echo "true"     # DocuCentre 750 I/650 I Series
    elif [ "${PrinterName}" = "AP24000" ]
    then
        echo "true"     # ApeosPort-II 5010/4000/3000 Series
    elif [ "${PrinterName}" = "DC24000" ]
    then
        echo "true"     # DocuCentre-II 5010/4000 Series
    elif [ "${PrinterName}" = "AP27000" ]
    then
        echo "true"     # ApeosPort-II 7000/6000 Series
    elif [ "${PrinterName}" = "DC27000" ]
    then
        echo "true"     # DocuCentre-II 7000/6000 Series
    elif [ "${PrinterName}" = "DC23005" ]
    then
        echo "true"     # DocuCentre-II 3005/2055/2005 Series
    elif [ "${PrinterName}" = "BinaryInstall205" ]
    then
        echo "true"     # BinaryInstall
    else
        echo "false"    # Not DocuPrint 205 Series
    fi
}

### DocuPrint 240A Series Check ###
P240Acheck() {
    if [ "${PrinterName}" = "DP240A" ]
    then
        echo "true"     # DocuPrint 240A Series
    else
        echo "false"    # Not DocuPrint 240A Series
    fi
}

################################
# Local functions
#
### turn off MSI/MailBox/Sorter
### nlecho message ###
nlecho() {
    echo ; echo $*
}

### errorexit exitcode message ###
errorexit() {
    nlecho "$progname:$2" 1>&2
    echo ; exit $1
}

### readparam message default_value
readparam() {
    if [ "$2" = "" ]; then
        echo ; echo "$1:\c"
        read parameter
    else
        echo ; echo "$1[$2]:\c"
        read parameter
        parameter="${parameter:-$2}"
    fi
}

### ask 'y' or 'n' ###
YesNo() {
    ans=""
    case "$2" in
        Yes|y) dmsg="y";;
        No|n) dmsg="n";;
        *) dmsg="";;
    esac
    while [ "$ans" = "" ]; do
        echo ; echo "$1(y/n)${dmsg:+[$dmsg]}:\c"
        read ans
        ans="${ans:-$dmsg}"
        if [ "$ans" = "y" -o "$ans" = "n" ]; then return ; fi
        echo "You must select 'y' or 'n'."
        ans=""
    done
}

### read printer name with confirm ###
ReadPrinterNameWithConfirm() {
    parameter=""
    msg=$1
        while [ "${parameter}" = "" ]; do
        readparam "Enter $msg?" ""
        if (echo ${parameter} | grep "[^a-zA-Z0-9_]"); then
            echo "$msg can contain alphanumeric characters and underscores"
            parameter=""
        else
            if [ "`echo ${parameter} | wc -c\c`" -le 14 ]; then
                YesNo "$msg is '${parameter}'" "y"
                if [ "$ans" = "n" ]; then
                    parameter=""
                fi
            else
                echo "$msg exceeds 14 character"
                parameter=""
            fi
        fi
    done
}

### Menu ###
Menu() {
    n=$#; i=1; tmp=$i
    while [ $i -le $n ]; do
        echo " ${i}. $1"
        if [ $i -gt 1 ]; then
            tmp="${tmp}/${i}"
        fi
        eval param_$i="\"$1\""
        shift; i=`expr $i + 1`
    done
    i=""; while [ "`expr $i + 0 2>&1`" != "$i" ]; do
        echo -n "Enter Process No(${tmp})?:"
        read i
    done
    eval ans=\$param_"$i"
    return $i
}

#Make binary install directry
mk_BINDIR() {
    bins="euc2ps2 xwd2ps2 xwd2g4 tiff2ps2 tiff2g4 ufptool"
    bins_gui_file=".UFPDefault"
    LINKBDIR=""
    WORKPARAM=""
    OK="n"
    while [ "${LINKBDIR}" = "" ]; do
        while [ "${OK}" = "n" ]; do
            readparam "Enter install directory name" "${BINDIR}"
            if [ `expr substr ${parameter} 1 1` != "/" ]; then
                YesNo "directory is '`pwd`/${parameter}'  " n
                WORKPARAM="`pwd`/${parameter}"
            else
                YesNo "directory is '${parameter}'  " n
                WORKPARAM="${parameter}"
            fi
            OK=${ans}
        done
        LINKBDIR="${WORKPARAM}"
        if [ -d ${LINKBDIR} ];then
            echo "'${LINKBDIR}' already exists."
            YesNo "Erase ${bins} in '${LINKBDIR}'. Confirm?" n
            if [ "$ans" = "y" ];then
                dir=`pwd`
                echo "'delete..."
                cd ${LINKBDIR}; rm -rf ${bins}
                cd ${dir}
                echo "done"
            fi
        fi
        if [ -d ${LINKBDIR}/UFPDefault ];then
            echo "'${LINKBDIR}/UFPDefault' already exist."
            YesNo "Erase ${bins_gui_file} in '${LINKBDIR}/UFPDefault'. Confirm?" n
            if [ "$ans" = "y" ];then
                dir=`pwd`
                echo -n "'delete..."
                cd ${LINKBDIR}; rm -rf ${bins_gui_file}
                cd ${dir}
                echo "done"
            fi
        fi
    done
    if [ "${LINKBDIR}" != "${BINDIR}" ];then
        mkdir -p ${LINKBDIR}
        BINDIR="${LINKBDIR}"
    else
        [ ! -d $BINDIR ] && mkdir -p $BINDIR
    fi
}

#Clean binary install directory for binary update
mk_UD_BINDIR() {
    bins="euc2ps2 xwd2ps2 xwd2g4 tiff2ps2 tiff2g4 ufptool"
    bins_gui_file=".UFPDefault"
    LINKBDIR=""
    WORKPARAM=""
    OK="n"
    while [ "${LINKBDIR}" = "" ]
    do
        while [ "${OK}" = "n" ]
        do
            readparam "Enter install directory name" "${BINDIR}"
            if [ `expr substr ${parameter} 1 1` != "/" ]
            then
                YesNo "directory is '`pwd`/${parameter}'  " n
                WORKPARAM="`pwd`/${parameter}"
            else
                YesNo "directory is '${parameter}'  " n
                WORKPARAM="${parameter}"
            fi
            OK=${ans}
        done
        LINKBDIR="${WORKPARAM}"
        if [ -d ${LINKBDIR} ]
        then
            dir=`pwd`
            echo "'Delete all old binary files...\c"
            cd ${LINKBDIR}
            rm -rf ${bins}
            rm -rf ${bins_gui}
            cd ${dir}
        else
            echo "Directory not found."
            echo "Binary update give up."
            exit 255
        fi
        if [ -d ${LINKBDIR}/UFPDefault ]
        then
            dir=`pwd`
            cd ${LINKBDIR}
            rm -rf ${bins_gui_file}
            cd ${dir}
            echo "done"
        fi
    done
}

### Extract ###
Extract() {
        if [ "`P240Acheck`" = "true" ]
        then
                EXEC=$EXEC_240A
        else
                EXEC=$EXEC_OTHERS
        fi

    for f in ${EXEC};
    do
        uncompress $f.Z
        cpset $f $BINDIR 0755 lp lp
    done

    if [ ! "`P240Acheck`" = "true" ]
        then
    		\rm -rf $BINDIR/xwd2g4 $BINDIR/tiff2g4
    		ln $BINDIR/xwd2ps2  $BINDIR/xwd2g4
    		ln $BINDIR/tiff2ps2  $BINDIR/tiff2g4
        		if [ ! -d $BINDIR/UFPDefault ]
    		then
        		mkdir $BINDIR/UFPDefault
    		fi
    		uncompress .UFPDefault.Z
    		cpset .UFPDefault $BINDIR/UFPDefault 0444 root sys
    		chmod 755 $BINDIR/UFPDefault
	fi

#    if [ -d $MANDIR ]
#    then
#        if [ ! -d $MANDIR/man1 ]
#        then
#            mkdir $MANDIR/man1
#        fi
#        for f in ${MAN};
#        do
#            uncompress $f.Z
#            cpset $f $MANDIR/man1 0444 bin bin
#        done
#    fi
    for f in ${EXEC};
    do
        rm -f $CURDIR/$f
    done
#    for f in ${MAN};
#    do
#        rm -f $CURDIR/$f
#    done
    for f in ${IFFILE};
    do
        rm -f $CURDIR/$f
    done
    rm -f $CURDIR/.UFPDefault
}

### Make Logical Interface File (for HP-UX) ###
# $* ... template filename list
make_logical_interface_hpux() {
    ## set output printer name
    TMPDIR=`$CURDIR/$CHANGE_EXEC $BINDIR`
    sed -e "s/PRINTER=/PRINTER="$OUTPUT_PNAME"/" \
        -e "s/HOME=/HOME="$TMPDIR"/" \
        < $CURDIR/$INTERFACE > $CURDIR/$INTERFACE.$LOGICAL_PNAME
    interface_hpux=`echo "$CURDIR/$INTERFACE.$LOGICAL_PNAME"`
}

### Register logical printer (for HP-UX) ###
register_logical_printer() {
    make_logical_interface_hpux
    lpadmin -p$LOGICAL_PNAME -v/dev/null -i$interface_hpux
    accept $LOGICAL_PNAME 2>&1 > /dev/null
    enable $LOGICAL_PNAME 2>&1 > /dev/null
    rm -f $interface_hpux
    rm -f $CURDIR/$CHANGE_EXEC
}

mylpsched() {
    TMP=$LANG
    LANG=C
    export LANG
    if [ ! "`lpstat -r`" = "scheduler is running" ]; then
        if [ ! -f /usr/lib/lpsched ]
        then
            echo "install.sh:should install LP-SPOOL filesets"
            exit
        fi
        /usr/lib/lpsched 2>&1 > /dev/null
    fi
    LANG=$TMP
    export LANG
}

mylpshut() {
    TMP=$LANG
    LANG=C
    export LANG
    if [ "`lpstat -r`" = "scheduler is running" ]; then
        if [ ! -f /usr/lib/lpshut ]
        then
            echo "install.sh:should install LP-SPOOL filesets"
            exit
        fi
        /usr/lib/lpshut 2>&1 > /dev/null
    fi
    LANG=$TMP
    export LANG
}

### HP-UX Install ###
HPUX_Install() {
    mylpsched
    echo; echo "HP-UX Installation for $PrinterName Type Printer"
    ### Input output-printer name
    ReadPrinterNameWithConfirm "output-printer-name" ""
    OUTPUT_PNAME=${parameter}
    TMP=`lpstat -a | awk '{print substr($1, 0, length($1))}' | grep $OUTPUT_PNAME`
    for i in $TMP
    do
        if [ "$i" = "$OUTPUT_PNAME" ]
        then
            break
        fi
    done
    while [ "$i" != "$OUTPUT_PNAME" ]
    do
        clear
        echo "The printer '$OUTPUT_PNAME' is not installed"
        ReadPrinterNameWithConfirm "output-printer-name" ""
        OUTPUT_PNAME=${parameter}
        TMP=`lpstat -a | awk '{print substr($1, 0, length($1))}' | grep $OUTPUT_PNAME`
        for i in $TMP
        do
            if [ "$i" = "$OUTPUT_PNAME" ]
            then
                break
            fi
        done
    done
    ### Input logical-printer name
    ReadPrinterNameWithConfirm "logical-printer-name" ""
    LOGICAL_PNAME=${parameter}
    TMP=`lpstat -a | awk '{print substr($1, 0, length($1))}' | grep $LOGICAL_PNAME`
    for i in $TMP
    do
        if [ "$i" = "$LOGICAL_PNAME" ]
        then
            break
        fi
    done
    while [ "$i" = "$LOGICAL_PNAME" ]
    do
        clear
        echo "The printer '$LOGICAL_PNAME' has already been installed"
        ReadPrinterNameWithConfirm "logical-printer-name" ""
        LOGICAL_PNAME=${parameter}
        TMP=`lpstat -a | awk '{print substr($1, 0, length($1))}' | grep $LOGICAL_PNAME`
        for i in $TMP
        do
            if [ "$i" = "$LOGICAL_PNAME" ]
            then
                break
            fi
        done
    done
    ### Install logical-printer
    mylpshut
    register_logical_printer
    mylpsched
}

### HP-UX Install ###
HPUX_BinaryInstall() {
    echo
    echo "HP-UX Binary update Installation"
}

setup_tapedevice() {
    case "`uname -s`" in
        HP-UX)
            case "`uname -r`" in
                A.09.*) TAPEDEV=/dev/rmt/0m ;;
                A.10.*) TAPEDEV=/dev/rmt/0m ;;
                A.11.*) TAPEDEV=/dev/rmt/0m ;;
            esac ;;
        *)
            echo; echo "Unsupported OS type."; exit 255 ;;
    esac
    if [ $?PACKAGE ]; then
        if [ -f $PACKAGE ]; then
            TAPEDEV=$PACKAGE
        else
            echo ;echo "Extracting a package, please wait..."
            tar xf $TAPEDEV $PACKAGE 2>&1 >/dev/null
            [ -f $PACKAGE ] && TAPEDEV=$PACKAGE
        fi
    fi  # if no package found, old version of Unix Filter
}

################################
# START Installation Here
################################
if [ "`whoami`" != "root" ]; then
    errorexit 255 "should be used by 'root'."
fi
ModelSelectMenu
setup_tapedevice
tar xf $PACKAGE
for f in ${INTERZ};
do
    uncompress $f
done
if [ ! "$PrinterName" = "BinaryInstall205" ]
then
    mk_BINDIR
    clear
    HPUX_Install
else
    YesNo "Update Binaries?" "y"
    if [ "$ans" = "y" ]
    then
        mk_UD_BINDIR
        HPUX_BinaryInstall
        rm -f $CURDIR/$CHANGE_EXEC
    else
        for f in ${IFFILE}
        do
            rm -f $CURDIR/$f
        done
        rm -f $CURDIR/$CHANGE_EXEC
        exit
    fi
fi

Extract
\rm ./version
if [ "`P205check`" = "true" ]
then
    MTYPE="205"
elif [ "`P240Acheck`" = "true" ]
then
    MTYPE="240A"
else
    MTYPE=""
fi
echo "${BINDIR}" > /tmp/fxbinpath${MTYPE}
mkdir -p /usr/lib/lp/postscript
cpset /tmp/fxbinpath${MTYPE} /usr/lib/lp/postscript 0755 root sys
rm -f /tmp/fxbinpath${MTYPE}
##[ -f ${PACKAGE} ] && rm -f $PACKAGE
echo ""; echo "done."
##### END-OF-INSTALL #####
