#!/bin/sh
#
# @(#)install.sh.m4 1.6 04/04/14 FX
#
# Installed System software for Fuji Xerox Asia Pacific Printer.
#
copyright="Copyright(C) 2007 by Fuji Xerox Asia Pacific Pte Ltd. All rights reserved."
progtitle="UNIX Driver Installer for Solaris (SPARC)"
progname="$0"

PATH=/usr/ucb:/bin:/etc:/usr/bin:/usr/etc:/usr/sbin

# Setup default parameters
PrinterName=""
HOSTNAME=""                     # net install host name
PACKAGE="uxdriver.tar"
#TAPEDEV="/dev/rfd0"
Solaris21_TAPEDEV="/dev/rfd0a"
Solaris22_TAPEDEV="/vol/dev/fd0/unlabeled"
Solaris23_TAPEDEV="/vol/dev/diskette0/unlabeled"
REWIND=""

#### directorys ###
ROOT=
CURDIR="`pwd`"
SAVEDIR="`pwd`/SAVED"

## mono Series
PACKAGE="uxdriver.tar"
BINDIR="${ROOT}/usr/local/fxbin"
LIBDIR="${ROOT}/usr/lib/fxps"
ETCDIR="${ROOT}/usr/local/fxetc"

## DocuPrint 205 Series
PACKAGE205="uxdriver2.tar"
BINDIR205="${ROOT}/usr/local/fxbin205"
LIBDIR205="${ROOT}/usr/lib/fxps205"
ETCDIR205="${ROOT}/usr/local/fxetc205"

## Fujiko Series
PACKAGE240A="uxdriver3.tar"
BINDIR240A="${ROOT}/usr/local/fxbin240A"
LIBDIR240A="${ROOT}/usr/lib/fxps240A"
ETCDIR240A="${ROOT}/usr/local/fxetc240A"

## monoSP Series
PACKAGESP="uxdriver4.tar"
BINDIRSP="${ROOT}/usr/local/fxbinSP"
LIBDIRSP="${ROOT}/usr/lib/fxpsSP"
ETCDIRSP="${ROOT}/usr/local/fxetcSP"

TERMINFO="${ROOT}/usr/share/lib/terminfo"
MODEL_PATH="${ROOT}/usr/lib/lp/model"

### utility for installation ###
## Solaris
bins_solaris="euc2ps2 sunras2ps2 tiff2ps2 xwd2ps2"
bins_gui="ufptool"
bins_gui_file=".UFPDefault"
#interface_solaris="LaserPress"
install_filters="download dpost postdaisy postdmd postio postior postmd postplot postprint postreverse posttek "    # need trailing space

# mono Series
##man1_solaris="euc2ps2.1 sunras2ps2.1 sunras2g4.1 tiff2ps2.1 tiff2g4.1 xwd2ps2.1 xwd2g4.1 fxpif.1"
##man5_solaris="posteuc.fd.5"
fds_solaris="posteuc.fd FXdownload.fd FXpostio.fd"

# DocuPrint 205 Series
##man1205_solaris="euc2ps2205.1 sunras2ps2205.1 sunras2g4205.1 tiff2ps2205.1 tiff2g4205.1 xwd2ps2205.1 xwd2g4205.1 fxpif205.1"
##man5205_solaris="posteuc205.fd.5"
fds205_solaris="posteuc205.fd FXdownload205.fd FXpostio205.fd"

# DocuPrint 240A Series
bins240A_solaris="txt2ps2 sunras2ps2 tiff2ps2 xwd2ps2"
##man1240A_solaris="txt2ps2240A.1 sunras2ps2240A.1 tiff2ps2240A.1 xwd2ps2240A.1 fxpif240A.1"
fds240A_solaris="posttxt240A.fd FXdownload240A.fd FXpostio240A.fd"

# monoSP Series
fds_solarisSP="posteucSP.fd FXdownloadSP.fd FXpostioSP.fd"

################################
## Printer Model Registration ##
################################
RegisterPrinterModels() {
    Model DC250      FXDC250.fd      "Document Centre 250/350/400"
    Model DC451      FXDC451.fd      "Document Centre 451/551"
    Model DC506      FXDC506.fd      "Document Centre 506/606/706"
    Model DC235      FXDC235.fd      "Document Centre 235/285/405"
    Model DP205      FXDP205.fd      "DocuPrint 205/255/305"
    Model DP240A     FXDP240A.fd     "DocuPrint 240A/340A"
    Model DC186      FXDC186.fd      "DocuCentre 1085/1055/186/156"
    Model DC286      FXDC286.fd      "Document Centre 286/236"
    Model DC1100     FXDC1100.fd     "Document Centre 1100/900"
    Model DC336      FXDC336.fd      "Document Centre 336"
    Model AP550I     FXAP550I.fd     "ApeosPort 550 I/450 I/350 I"
    Model DC550I     FXDC550I.fd     "DocuCentre 550 I/450 I"
    Model AP750I     FXAP750I.fd     "ApeosPort 750 I/650 I"
    Model DC750I     FXDC750I.fd     "DocuCentre 750 I/650 I"
    Model DC23005    FXDC23005.fd    "DocuCentre-II 3005/2055/2005"
    Model AP24000    FXAP24000.fd    "ApeosPort-II 5010/4000/3000"
    Model DC24000    FXDC24000.fd    "DocuCentre-II 5010/4000"
    Model AP27000    FXAP27000.fd    "ApeosPort-II 7000/6000"
    Model DC27000    FXDC27000.fd    "DocuCentre-II 7000/6000"
    Model BinaryInstall205  dummy.fd        "Binary update only"
} #EndRegisterPrinterModels

# model_pt<n> ... printer model name
# model_fd<n> ... Solaris FD file name
# model_mn<n> ... menu string
Model() {
    [ x"$ModelCount" = x ] && ModelCount=0
    eval ModelCount=`expr $ModelCount + 1`
    eval model_pt$ModelCount=$1
    eval model_fd$ModelCount=$2
    eval model_mn$ModelCount="\"$3\""
    eval fd_$1=$2
}

## Display Model Selet Menu
ModelSelectMenu() {
    echo "Please wait..."
    RegisterPrinterModels
    clear
    echo "$progtitle" ;echo "$copyright" ;echo ""
    echo "Printer Model?"
    i=1; tmp=$i; menustr=x
    while [ x"$menustr" != xExit ]; do
        eval menustr="\"\$model_mn$i\""
        [ $i -gt $ModelCount ] && menustr="Exit"
        echo "  ${i}. $menustr"
        [ $i -gt 1 ] && tmp="${tmp}/${i}"
        i=`expr $i + 1`
    done
    i=""; while [ "`expr $i + 0 2>&1`" != "$i" ]; do
        echo -n "Enter Process No(${tmp})?:"
        read i
    done
    if [ $i -gt $ModelCount ]; then
        EJECT; exit;
    fi
    eval PrinterName=\$model_pt$i

    if [ "`P205check`" = "true" ]
    then
        PACKAGE=$PACKAGE205
        BINDIR=$BINDIR205
        LIBDIR=$LIBDIR205
        ETCDIR=$ETCDIR205
##        man1_solaris=$man1205_solaris
##        man5_solaris=$man5205_solaris
        fds_solaris=$fds205_solaris
    elif [ "`P240Acheck`" = "true" ]
    then
        PACKAGE=$PACKAGE240A
        BINDIR=$BINDIR240A
        LIBDIR=$LIBDIR240A
        ETCDIR=$ETCDIR240A
        bins_solaris=$bins240A_solaris
##        man1_solaris=$man1240A_solaris
        fds_solaris=$fds240A_solaris
    elif [ "`PSPcheck`" = "true" ]
    then
        PACKAGE=$PACKAGESP
        BINDIR=$BINDIRSP
        LIBDIR=$LIBDIRSP
        ETCDIR=$ETCDIRSP
        fds_solaris=$fds_solarisSP
    fi
}

### DocuPrint 205 Series Check ###
P205check() {
    if [ "${PrinterName}" = "DP205" ]
    then
        echo "true"     # DocuPrint 205 Series
    elif [ "${PrinterName}" = "DC186" ]
    then
        echo "true"     # DocuCentre 1085/1055/186/156 Series
    elif [ "${PrinterName}" = "DC286" ]
    then
        echo "true"     # Document Centre 286/236 Series
    elif [ "${PrinterName}" = "DC1100" ]
    then
        echo "true"     # Document Centre 1100/900 Series
    elif [ "${PrinterName}" = "DC336" ]
    then
        echo "true"     # Document Centre 336 Series
    elif [ "${PrinterName}" = "AP550I" ]
    then
        echo "true"     # ApeosPort 550 I/450 I/350 I Series
    elif [ "${PrinterName}" = "DC550I" ]
    then
        echo "true"     # DocuCentre 550 I/450 I Series
    elif [ "${PrinterName}" = "AP750I" ]
    then
        echo "true"     # ApeosPort 750 I/650 I Series
    elif [ "${PrinterName}" = "DC750I" ]
    then
        echo "true"     # DocuCentre 750 I/650 I Series
    elif [ "${PrinterName}" = "AP24000" ]
    then
        echo "true"     # ApeosPort-II 5010/4000/3000 Series
    elif [ "${PrinterName}" = "DC24000" ]
    then
        echo "true"     # DocuCentre-II 5010/4000 Series
    elif [ "${PrinterName}" = "AP27000" ]
    then
        echo "true"     # ApeosPort-II 7000/6000 Series
    elif [ "${PrinterName}" = "DC27000" ]
    then
        echo "true"     # DocuCentre-II 7000/6000 Series
    elif [ "${PrinterName}" = "DC23005" ]
    then
        echo "true"     # DocuCentre-II 3005/2055/2005 Series
    elif [ "${PrinterName}" = "BinaryInstall205" ]
    then
        echo "true"     # BinaryInstall
    else
        echo "false"    # Not DocuPrint 205 Series
    fi
}

################################
### DocuPrint 240A Series Check ###
P240Acheck() {
    if [ "${PrinterName}" = "DP240A" ]
    then
        echo "true"     # DocuPrint 240A Series
    else
        echo "false"    # Not DocuPrint 240A Series
    fi
}

################################
### mono (Secure Print) Series Check ###
PSPcheck() {
    if [ "${PrinterName}" = "DC506" ]
    then
        echo "true"     # DocuCentre 506 Series
    elif [ "${PrinterName}" = "DC235" ]
    then
        echo "true"     # DocuCentre 235 Series
    else
        echo "false"    # Not DocuCentre 506 or 235 Series
    fi
}

# Local functions
#
### turn off MSI/MailBox/Sorter
CutOff() {
    egrep -v 'MSI|m1|m2|m3|m4|m5|m6|m7|m8|m9|m10|Ost' $1
}

### nlecho message ###
nlecho() {
    echo ; echo $*
}
### errorexit exitcode message ###
errorexit() {
    nlecho "$progname:$2" 1>&2
    ${EJECT}
    echo ; exit $1
}
### readparam message default_value
readparam() {
    if [ "$2" = "" ]; then
        echo ; echo -n "$1:"
        read parameter
    else
        echo ; echo -n "$1[$2]:"
        read parameter
        parameter="${parameter:-$2}"
    fi
}
### readenum message default_value
readenum() {
    parameter=""
    while [ "${parameter}" = "" ]; do
        echo ; echo -n "$1(1:$2 2:$3):"
        read parameter
        if [ "${parameter}" = "1" ]; then
            parameter="$2"
        elif [ "${parameter}" = "2" ]; then
            parameter="$3"
        else
            parameter=""
        fi
    done
}
### ask 'y' or 'n' ###
YesNo() {
    ans=""
    case "$2" in
    Yes|y) dmsg="y";;
    No|n)  dmsg="n";;
    *)   dmsg="";;
    esac
    while [ "$ans" = "" ]; do
        echo ; echo -n "$1(y/n)${dmsg:+[$dmsg]}:"
        read ans
        ans="${ans:-$dmsg}"
        if [ "$ans" = "y" -o "$ans" = "n" ]; then return ; fi
        echo "You must select 'y' or 'n'."
        ans=""
    done
}
### Menu ###
Menu() {
    n=$#; i=1; tmp=$i
    while [ $i -le $n ]; do
        echo "  ${i}. $1"
        if [ $i -gt 1 ]; then
            tmp="${tmp}/${i}"
        fi
        eval param_$i="\"$1\""
        shift; i=`expr $i + 1`
    done
    i=""; while [ "`expr $i + 0 2>&1`" != "$i" ]; do
        echo -n "Enter Process No(${tmp})?:"
        read i
    done
    eval ans=\$param_"$i"
    return $i
}

### Extract ###
Extract() {
    install_directory=$1
    shift 1
    install_Zfiles=""
    install_files=""
    for f in $*; do
       install_Zfiles="${install_Zfiles} ${f}.Z"
       install_files="${install_files} $f"
    done

    ${REWIND}
    cwd=`pwd`
    cd ${CURDIR}
    tar xvf ${TAPEDEV} ${install_Zfiles}
    for f in ${install_files}; do
       uncompress ${f}
       install -g lp -o lp $f ${install_directory}
       /bin/rm ${CURDIR}/$f
    done
    cd $cwd
}

### filename ###
filename() {
    set `echo $1 | sed 's/\// /g'`
    shift `expr $# - 1`
    echo $1
}

### found ###
found() {
    for i in $1; do
        if [ "${i}" = $2 ]; then
            return 0
        fi
    done
    return 1
}

### keyedit edit_file key addfile saved ###
keyedit() {
    echo -n "   $1 ... "
    RC=255
    grep "$2" $1 >/dev/null 2>&1
    case "$?" in
    0) echo "already edited.";;
    2) echo "file not found.";;
    1) if [ ! -f "$4/`filename $1`" ]; then
            cp $1 $4
            RC=0
        fi
        if [ -w $1 ]; then
            cat $3 >> $1 2>/dev/null
            echo "done"
        else
            echo "Permission denied."
        fi
        ;;
    esac
    return ${RC}
}
### read parameter with confirm ###
ReadParamWithConfirm()  {
    parameter=""
    while [ "${parameter}" = "" ]; do
        readparam "Enter $1?" "$2"
        if [ "$#" = "2" ]; then
            YesNo "$1 is '${parameter}'" "y"
            if [ "$ans" = "n" ]; then
                parameter=""
            fi
        elif [ $3 ${parameter} ]; then
            parameter=""
        fi
    done
}

### read printer name with confirm ###
ReadPrinterNameWithConfirm() {
    parameter=""
    while [ "${parameter}" = "" ]; do
        readparam "Enter $1?" "$2"
        if (echo ${parameter} | grep "[^a-zA-Z0-9_]"); then
            echo "$1 can contain alphanumeric characters and underscores"
            parameter=""
        else
            if [ "`echo -n ${parameter} | wc -c`" -le 14 ]; then
                YesNo "$1 is '${parameter}'" "y"
                if [ "$ans" = "n" ]; then
                    parameter=""
                fi
            else
                echo "$1 exceeds 14 characters"
                parameter=""
            fi
        fi
    done
}

#Make binary install directry
mk_SolarisBINDIR()  {
    all_bins=""
    LINKBDIR=""
    WORKPARAM=""
    OK="n"
    while [ "${LINKBDIR}" = "" ]; do
        while [ "${OK}" = "n" ]; do
            readparam "Enter binary directory name" "${BINDIR}"
            if [ `expr substr ${parameter} 1 1` != "/" ]; then
                YesNo "directory is '`pwd`/${parameter}'  " n
                WORKPARAM="`pwd`/${parameter}"
            else
                YesNo "directory is '${parameter}'  "     n
                WORKPARAM="${parameter}"
            fi
            OK=${ans}
        done
        LINKBDIR="${WORKPARAM}"
        if [ -d ${LINKBDIR} ];then
            echo "'${LINKBDIR}' already exists."
            ## add 990510 for GUI tool install ##

            if [ "`Solaris24`" = "true" ]; then
                YesNo "Erase ${bins_solaris} ${bins_gui} in '${LINKBDIR}'. Confirm?" n
            else
                YesNo "Erase ${bins_solaris} in '${LINKBDIR}'. Confirm?" n
            fi
            ## add end ##
            if [ "$ans" = "y" ];then
                dir=`pwd`
                echo -n "'delete..."
                ## add 990510 for GUI tool install ##
                if [ "`Solaris24`" = "true" ]; then
                    cd ${LINKBDIR}; rm -rf ${bins_solaris} ${bins_gui}
                else
                    cd ${LINKBDIR}; rm -rf ${bins_solaris}
                fi
                ## add end ##
                cd ${dir}
                echo "done"
            fi
        fi
        ## add 990510 for GUI tool install ##
        if [ -d ${LINKBDIR}/UFPDefault ];then
            echo "'${LINKBDIR}/UFPDefault' already exists."
            YesNo "Erase ${bins_gui_file} in '${LINKBDIR}/UFPDefault'. Confirm?" n
            if [ "$ans" = "y" ];then
                dir=`pwd`
                echo -n "'delete..."
                cd ${LINKBDIR}; rm -rf ${bins_gui_file}
                cd ${dir}
                echo "done"
            fi
        fi
        ## add end ##
    done
    if [ "${LINKBDIR}" != "${BINDIR}" ];then
        BINDIR="${LINKBDIR}"
    else
        [ ! -d $BINDIR ] && mkdir $BINDIR
        ## add 990510 for GUI tool install ##
        if [ "`Solaris24`" = "true" ]; then
                [ ! -d $BINDIR/UFPDefault ] && mkdir $BINDIR/UFPDefault
        fi
        ## add end ##
    fi
}

#Clean binary install directory for Solaris binary update
mk_Solaris_UD_BINDIR() {
    LINKBDIR=""
    WORKPARAM=""
    OK="n"
    while [ "${LINKBDIR}" = "" ]
    do
        while [ "${OK}" = "n" ]
        do
            readparam "Enter binary directory name" "${BINDIR}"
            if [ `expr substr ${parameter} 1 1` != "/" ]
            then
                YesNo "directory is '`pwd`/${parameter}'  " n
                WORKPARAM="`pwd`/${parameter}"
            else
                YesNo "directory is '${parameter}'  " n
                WORKPARAM="${parameter}"
            fi
            OK=${ans}
        done
        LINKBDIR="${WORKPARAM}"
        if [ -d ${LINKBDIR} ]
        then
            dir=`pwd`
            echo -n "'Delete all old binary files..."
            if [ "`Solaris24`" = "true" ]
            then
                cd ${LINKBDIR}
                rm -rf ${bins_solaris} ${bins_gui}
            else
                cd ${LINKBDIR}
                rm -rf ${bins_solaris}
            fi
            cd ${dir}
        else
            echo "Directory not found."
            echo "Binary update give up."
            exit 255
        fi
        if [ -d ${LINKBDIR}/UFPDefault ]
        then
            dir=`pwd`
            cd ${LINKBDIR}
            rm -rf ${bins_gui_file}
            cd ${dir}
            echo "done"
        fi
    done
}

### do symbolic link ###
LN_S() {
    [ -f $2 ] && rm -f $2   # remove, if $2 already exists.
    ln -s $1 $2
}
### do hard link ###
LN_H() {
    [ -f $2 ] && rm -f $2   # remove, if $2 already exists.
    ln $1 $2
}

### Register filters by lpfilter command (For Solaris) ###
register_filters() {
    dir=`pwd`
    cd /etc/lp/fd
    regsitered=`lpfilter -f all -l | awk -F\" '/^\(Filter /{print $2}'`
    reinstall=""
    for f in ${regsitered}; do
        if [ -f ${f}.fd ]; then
            if (found "${install_filters}" ${f}); then
                YesNo "Do you want remove '${f}'filter and re-install" "y"
                if [ "$ans" = "y" ]; then
                    reinstall="${reinstall} ${f} "
                fi
            fi
        fi
    done
    for f in ${solaris_filters}; do
        lpfilter -f ${f} -F ${f}.fd
    done
    for f in ${install_filters}; do
        if [ -f ${f}.fd ]; then
            if (found "${reinstall}" ${f}); then
                lpfilter -f ${f} -x
                lpfilter -f ${f} -F ${f}.fd
            elif (found "${regsitered}" ${f}); then
                echo -n ""
            else
                YesNo "Do you want install '${f}'filter" "y"
                if [ "$ans" = "y" ]; then
                    lpfilter -f ${f} -F ${f}.fd
                fi
            fi
        fi
    done
    cd ${dir}
}


### Add Port Service (For Solaris) ###
addport_service() {
    YesNo "Do you want set port-monitor?" "y"
    if [ "$ans" = "y" ]; then
        UA=`lpsystem -A`
        UA0=`lpsystem -A|awk '{printf("%s0ACE%s",substr($1,1,4),substr($1,9))}'`
        sacadm -a -p tcp -t listen -c "/usr/lib/saf/listen tcp" \
               -v `nlsadmin -V` \
               -n 9999 2> /dev/null
        pmadm  -a -p tcp -s lp  -i root \
            -m `nlsadmin -o /var/spool/lp/fifos/listenS5` \
            -v `nlsadmin -V`\ 2> /dev/null
        pmadm   -a -p tcp -s lpd -i root \
            -m `nlsadmin -o /var/spool/lp/fifos/listenBSD -A "\x${UA}"`\
            -v `nlsadmin -V` 2> /dev/null
        pmadm    -a -p tcp -s 0   -i root \
            -m `nlsadmin -c /usr/lib/saf/nlps_server -A "\x${UA0}"`\
            -v `nlsadmin -V` 2> /dev/null
    fi
}

### Extract solaris binary from tape ###
install_solaris_binary() {
    # making installed FD files
    eval fd=\$fd_"$PrinterName"
    fds_solaris="$fds_solaris $fd"
##    man5_solaris="$man5_solaris ${fd}.5"
    solaris_filters=""
    for i in $fds_solaris; do
        solaris_filters="$solaris_filters `basename $i .fd`"
    done

    install -d -m 755 ${BINDIR}

    ## add 990510 for GUI tool install ##
    if [ "`Solaris24`" = "true" ]; then
        install -d -m 755 ${BINDIR}/UFPDefault
    fi
    Extract ${BINDIR}     ${bins_solaris}

    ## add 990510 for GUI tool install ##
    if [ "`Solaris24`" = "true" ]; then
        Extract ${BINDIR}       ${bins_gui}
        Extract ${BINDIR}/UFPDefault    ${bins_gui_file}
    fi

    Extract /etc/lp/fd    ${fds_solaris}
##    if [ -d ${MANDIR} ]; then
##        Extract ${MANDIR}/man1 ${man1_solaris}
##        if [ "`P240Acheck`" != "true" ]; then
##            Extract ${MANDIR}/man5 ${man5_solaris}
##        fi
##    fi

    # do binary hard link
    if [ "`P240Acheck`" = "true" ]; then
       LN_H ${BINDIR}/txt2ps2    ${BINDIR}/fxpif
    else
       LN_H ${BINDIR}/euc2ps2    ${BINDIR}/fxpif
    fi
    LN_H ${BINDIR}/sunras2ps2 ${BINDIR}/sunras2g4
    LN_H ${BINDIR}/tiff2ps2   ${BINDIR}/tiff2g4
    LN_H ${BINDIR}/xwd2ps2    ${BINDIR}/xwd2g4

    # do symbolic link
    if [ "`P205check`" = "true" ]
    then
        MTYPE="205"
    elif [ "`P240Acheck`" = "true" ]
    then
        MTYPE="240A"
    elif [ "`PSPcheck`" = "true" ]
    then
        MTYPE="SP"
    else
        MTYPE=""
    fi


    if [ "`P240Acheck`" = "true" ]; then
        LN_S ${BINDIR}/txt2ps2 /usr/lib/lp/postscript/posttxt${MTYPE}
    else
        LN_S ${BINDIR}/euc2ps2 /usr/lib/lp/postscript/posteuc${MTYPE}
    fi
    LN_S ${BINDIR}/fxpif  /usr/lib/lp/postscript/postfxps${MTYPE}

    if [ "`P240Acheck`" = "true" ]; then
        /usr/bin/chown -h lp /usr/lib/lp/postscript/posttxt${MTYPE} /usr/lib/lp/postscript/postfxps${MTYPE}
        /usr/bin/chgrp -h lp /usr/lib/lp/postscript/posttxt${MTYPE} /usr/lib/lp/postscript/postfxps${MTYPE}
    else
        /usr/bin/chown -h lp /usr/lib/lp/postscript/posteuc${MTYPE} /usr/lib/lp/postscript/postfxps${MTYPE}
        /usr/bin/chgrp -h lp /usr/lib/lp/postscript/posteuc${MTYPE} /usr/lib/lp/postscript/postfxps${MTYPE}
    fi

    #addstart (99/04/12)
    echo "${BINDIR}" > /tmp/fxbinpath${MTYPE}
    install -g bin -o root /tmp/fxbinpath${MTYPE} /usr/lib/lp/postscript
    rm -f /tmp/fxbinpath${MTYPE}
    #addend (99/04/12)

    ## make terminfo link ###
    firstchar=`echo ${PrinterName}|awk '{printf("%s",substr($1,1,1))}`
    if [ ! -d ${TERMINFO}/${firstchar} ]; then
        mkdir ${TERMINFO}/${firstchar}
    fi
    LN_S ${TERMINFO}/P/PS ${TERMINFO}/${firstchar}/${PrinterName}
}

### Extract solaris update binary from TAR file ###
install_solaris_update_binary() {
    # making installed FD files
    fds_solaris="$fds_solaris $fd"
##    man5_solaris="$man5_solaris ${fd}.5"
    solaris_filters=""
    install -d -m 755 ${BINDIR}
    if [ "`Solaris24`" = "true" ]
    then
        install -d -m 755 ${BINDIR}/UFPDefault
    fi
    Extract ${BINDIR} ${bins_solaris}
    if [ "`Solaris24`" = "true" ]
    then
        Extract ${BINDIR} ${bins_gui}
        Extract ${BINDIR}/UFPDefault ${bins_gui_file}
    fi
##    if [ -d ${MANDIR} ]
##    then
##        Extract ${MANDIR}/man1 ${man1_solaris}
##    fi
    # do binary hard link
    LN_H ${BINDIR}/euc2ps2 ${BINDIR}/fxpif
    LN_H ${BINDIR}/sunras2ps2 ${BINDIR}/sunras2g4
    LN_H ${BINDIR}/tiff2ps2 ${BINDIR}/tiff2g4
    LN_H ${BINDIR}/xwd2ps2 ${BINDIR}/xwd2g4
    # do symbolic link
    if [ "`P205check`" = "true" ]
    then
        MTYPE="205"
    elif [ "`P240Acheck`" = "true" ]
    then
        MTYPE="240A"
    elif [ "`PSPcheck`" = "true" ]
    then
        MTYPE="SP"
    else
        MTYPE=""
    fi
    LN_S ${BINDIR}/fxpif /usr/lib/lp/postscript/postfxps${MTYPE}
    if [ "`P240Acheck`" = "true" ]; then
        LN_S ${BINDIR}/txt2ps2 /usr/lib/lp/postscript/posttxt${MTYPE}
        /usr/bin/chown -h lp /usr/lib/lp/postscript/posttxt${MTYPE} /usr/lib/lp/
postscript/postfxps${MTYPE}
        /usr/bin/chgrp -h lp /usr/lib/lp/postscript/posttxt${MTYPE} /usr/lib/lp/
postscript/postfxps${MTYPE}
    else
        LN_S ${BINDIR}/euc2ps2 /usr/lib/lp/postscript/posteuc${MTYPE}
        /usr/bin/chown -h lp /usr/lib/lp/postscript/posteuc${MTYPE} /usr/lib/lp/
postscript/postfxps${MTYPE}
        /usr/bin/chgrp -h lp /usr/lib/lp/postscript/posteuc${MTYPE} /usr/lib/lp/
postscript/postfxps${MTYPE}
    fi
    echo "${BINDIR}" > /tmp/fxbinpath${MTYPE}
    install -g bin -o root /tmp/fxbinpath${MTYPE} /usr/lib/lp/postscript
    rm -f /tmp/fxbinpath${MTYPE}
}

### Solaris 2.6 check ###
Solaris26() {
    if [ "`uname -s`" = "SunOS" -a `uname -r |cut -d. -f2` -ge 6 ]; then
        echo "true" # Solaris 2.6 or later
    else
        echo "false"    # Solaris 2.5 or older
    fi
}

## add 990510 for GUI tool install ##
### Solaris 2.4 check ###
Solaris24() {
    if [ "`uname -s`" = "SunOS" -a `uname -r |cut -d. -f2` -ge 5 ]; then
        echo "true" # Solaris 2.5 or later
    else
        echo "false"    # Solaris 2.4 or older
    fi
}

### Make Interface File (for Solaris) ###
# $* ... template filename list
make_interface_solaris() {
    interface_solaris=""
    for i in $*; do
    if [ -f $MODEL_PATH/$i ]; then
        interface_solaris=$PrinterName
        sed -e "s/\([^A-Za-z]*\)PS\([^A-Za-z]\)/\1$PrinterName\2/g" \
        -e "s/\([^A-Za-z]*\)PS\(R[^A-Za-z]\)/\1$PrinterName\2/g" \
        -e 's/\(\`*.\)\(date .*\`\)/\1env LANG=C \2/g' \
        $MODEL_PATH/$i >$interface_solaris
        install -c -o lp -g lp $interface_solaris $MODEL_PATH
        rm -f $interface_solaris
        break
    fi
    done
    if [ $interface_solaris = "" ]; then
    if [ "`Solaris26`" = "true" ]; then
        errorexit 255 "should install SUNWpsu/SUNWjfpu Package."
    else # Solaris 2.5.1 or older...
        errorexit 255 "should install SUNWlps/SUNWjfpu Package."
    fi
    fi
}

### Register local printer (for Solaris) ###
register_local_printer() {
    mk_SolarisBINDIR
    install_solaris_binary
    register_filters
    ### jstandard in Solaris 2.5-JFP is buggy!
    #make_interface_solaris ifdef(/*JP*/,jstandard) standard
    make_interface_solaris standard
    lpadmin -p $NAME -T $PrinterName -I PS -D "$COMMENT" \
        -v $PORT -i $MODEL_PATH/$interface_solaris
    accept $NAME ;enable $NAME
}

### Register network printer with local filtering (for Solaris) ###
register_network_printer() {
##  MODEL_PATH=/usr/lib/lp/model
    mk_SolarisBINDIR
    install_solaris_binary
    register_filters
    if [ "`Solaris26`" = "true" ]; then
        make_interface_solaris netstandard
        # register network printer
        lpadmin -p $NAME -T $PrinterName -I PS \
            -D "$COMMENT" -o dest=${PSERVER}:${RPRINTER} -o protocol=bsd \
            -v /dev/null -i $MODEL_PATH/$interface_solaris
    else
        lpsystem -t bsd $PSERVER
        lpadmin -p $NAME -T $PrinterName -I PS \
            -D "$COMMENT" -s ${PSERVER}\!${RPRINTER}
    fi
    accept $NAME ;enable $NAME
}

### Register remote system access (for Solaris) ###
register_remote_system() {
    mk_SolarisBINDIR
    if [ "`Solaris26`" = "true" ]; then
        lpadmin -p $NAME -s ${PSERVER}\!${RPRINTER}
        lpset -a description="$COMMENT" $NAME
    else
        readenum  "Enter '$PSERVER' system?" "s5" "bsd"
        SYSTEM=${parameter}
        lpsystem -t $SYSTEM $PSERVER
        YesNo "Use Filter in Print Server" "y"
        if [ "$ans" = "y" ]; then
            lpadmin -p $NAME -T PS -I any \
                -s ${PSERVER}\!${RPRINTER} -D "$COMMENT"
        else
            install_solaris_binary
            register_filters
            lpadmin -p $NAME -T $PrinterName -I PS \
                -s ${PSERVER}\!${RPRINTER} -D "$COMMENT"
        fi
        accept $NAME ;enable $NAME
    fi
}

### Install Solaris binary files (for UPDATE MODE)###
Solaris_BinaryInstall() {
    YesNo "Update binaries?" "y"
    if [ "$ans" = "y" ]
    then
        mk_Solaris_UD_BINDIR
        install_solaris_update_binary
    fi
}

### Eject floppy ###
EJECT() {
    case "`uname -s`" in
    SunOS)
        case `uname -r` in
        4.*) eject floppy ;;
        5.*) [ -h /vol/dev/aliases/floppy0 ] && eject floppy ;;
        *) ;;
        esac ;;
    *) ;;
    esac
}

### Solaris Install ###
Solaris_Install()   {
    COMMENT="Fuji Xerox $PrinterName Type Printer"
    if [ ! "`lpstat -r`" = "scheduler is running" ]; then
        /usr/lib/lp/lpsched
        if [ ! "`lpstat -r`" = "scheduler is running" ]; then
            if [ "`Solaris26`" = "true" ]; then
            errorexit 255 "should install SUNWpsu Package."
            else
            errorexit 255 "should install SUNWlpu Package."
            fi
        fi
    fi
    ##echo; echo "Solaris Installation for Laser Press"
    ##Menu "Set Local Printer" "Set Printer Server" "Set Remote Printer"
    echo; echo "Solaris Installation for $PrinterName Type Printer"
    Menu "Set Local Printer" "Set Remote Printer"
    if [ "${ans}" = "Set Local Printer" ]; then
        PORT=/dev/term/a  # serial
        ReadParamWithConfirm "port-device-name" "$PORT" "! -c "
        PORT=${parameter}
        chown lp  ${PORT} ;chmod 600 ${PORT}
        ReadPrinterNameWithConfirm "printer-name" "${PrinterName}"
        NAME=${parameter}
        register_local_printer
        [ "`Solaris26`" = "false" ] && addport_service
    elif [ "${ans}" = "Set Printer Server" ]; then
        OK="n"
        while [ "${OK}" = "n" ]; do
            readparam "Enter client-hostnames" ""
            OK="y"
            for i in ${parameter}; do
                YesNo "Client is '${i}' " "Yes"
                if [ "${ans}" = "n" ]; then
                    OK="n"
                    break
                fi
            done
        done
        HOSTS=${parameter}
        for HOST in ${HOSTS}; do
            readenum "Enter '${HOST}'system?" "s5" "bsd"
            lpsystem -t ${parameter} ${HOST}
        done
        addport_service
    elif [ "${ans}" = "Set Remote Printer" ]; then
        ReadParamWithConfirm "server-hostname" ""
        PSERVER=${parameter}
        ReadPrinterNameWithConfirm "server-printer-name" ""
        RPRINTER=${parameter}
        ReadPrinterNameWithConfirm "client-printer-name" ""
        NAME=${parameter}
        YesNo "'$PSERVER' is network printer" "y"
        if [ "$ans" = "y" ]; then
            register_network_printer
        else
            register_remote_system
        fi
    fi
}

setup_tapedevice() {
    case "`uname -s`" in
    SunOS)
        case "`uname -r`" in
            5.1) TAPEDEV=$Solaris21_TAPEDEV ;;
            5.2) TAPEDEV=$Solaris22_TAPEDEV ;;
              *) TAPEDEV=$Solaris23_TAPEDEV ;;
        esac ;;
        *)
        echo; echo "Unsupported OS type."; exit 255 ;;
    esac
    if [ $?PACKAGE ]; then
        if [ -f $PACKAGE ]; then
            TAPEDEV=$PACKAGE
        else
            echo ;echo "Extracting a package, please wait..."
            tar xf $TAPEDEV $PACKAGE 2>&1 >/dev/null
            [ -f $PACKAGE ] && TAPEDEV=$PACKAGE
        fi
    fi  # if no package found, old version of Unix Filter
}

################################
# START Installation Here
################################
#/usr/ucb/clear
if [ "`whoami`" != "root" ]; then
    errorexit 255 "should be used by 'root'."
fi
if [ ! -d ${SAVEDIR} ]; then mkdir ${SAVEDIR} ; fi
SAVE_FILES=""

ModelSelectMenu
setup_tapedevice

if [ ! "$PrinterName" = "BinaryInstall205" ]; then
   Solaris_Install
else
    Solaris_BinaryInstall
fi

##[ -f $PACKAGE ] && rm -f $PACKAGE
echo ""; echo "done."

EJECT
##### END-OF-INSTALL #####
