#!/bin/sh
#
# @(#)install.sh.m4 1.6 04/11/05 XSSC
#
# Installed System software for Fuji Xerox AP Printer.
#
copyright="Copyright(C) 2008 Fuji Xerox Asia Pacific Pte Ltd. All rights reserved."
progtitle="FXAP UNIX Driver Installer for Redhat Linux"
progname="$0"

PATH=/usr/ucb:/bin:/etc:/usr/bin:/usr/etc:/usr/sbin

# Setup default parameters
PrinterName=""
HOSTNAME=""         # net install host name
TAPEDEV="/dev/fd0"
REWIND=""

#### directorys ###
ROOT=
CURDIR="`pwd`"
SAVEDIR="`pwd`/SAVED"
SAMPLEDIR="${ROOT}/usr/local/fxsrc"
#MANDIR="${ROOT}/usr/man/ja_JP.ujis"
#MANDIR2="${ROOT}/usr/man/ja_JP.eucJP"
#MANDIRF="${ROOT}/usr/share/man/ja"
PRINTCAP="${ROOT}/etc/printcap"
TERMINFO="${ROOT}/usr/share/lib/terminfo"
MODEL_PATH="${ROOT}/usr/lib/lp/model"
RESOURCEDIR="${ROOT}/usr/X11R6/lib/X11/app-defaults"

## mono Series
PACKAGE="uxdriver.tar"
BINDIR="${ROOT}/usr/local/fxbin"
LIBDIR="${ROOT}/usr/lib/fxps"
ETCDIR="${ROOT}/usr/local/fxetc"

## mono205 Series
PACKAGE205="uxdriver2.tar"
BINDIR205="${ROOT}/usr/local/fxbin205"
LIBDIR205="${ROOT}/usr/lib/fxps205"
ETCDIR205="${ROOT}/usr/local/fxetc205"

## DocuPrint 240A Series
PACKAGE240A="uxdriver3.tar"
BINDIR240A="${ROOT}/usr/local/fxbin240A"
LIBDIR240A="${ROOT}/usr/lib/fxps240A"
ETCDIR240A="${ROOT}/usr/local/fxetc240A"
bins240A="txt2ps2 tiff2ps2 xwd2ps2 printcap.sample .fxpsdefault240A ufptool fxoption fxoption_exec string_from_printcap"

### utility for installation ###
## Redhat Linux
bins="euc2ps2 fxoption tiff2ps2 xwd2ps2"
libs="fxpof fxoption_exec string_from_printcap fxbanner.ps fxpif_sample.sh"
printcap="printcap.add"
filter="fxpif fxpof fxpvf fxpg4f"
filter_add="A3 A4"

# for Laser Press 2100PS
samples2100="sample.tar"
printcap2100="printcap-2100.add"

## mono Series
defaults=".fxpsdefault"
#man1="euc2ps2.1 fxoption.1 fxpif.1 fxpof.1 fxpvf.1 fxpg4f.1 tiff2ps2.1 tiff2g4.1 xwd2ps2.1 xwd2g4.1"
#man5="fxpsdefault.5"

## mono205 Series
defaults205=".fxpsdefault205"
#man1205="euc2ps2205.1 fxoption205.1 fxpif205.1 fxpof205.1 fxpvf205.1 fxpg4f205.1 tiff2ps2205.1 tiff2g4205.1 xwd2ps2205.1 xwd2g4205.1"
#man5205="fxpsdefault205.5"

## DocuPrint 240A Series
defaults240A=".fxpsdefault240A"
#man1240A="txt2ps2240A.1 fxpif240A.1 tiff2ps2240A.1 xwd2ps2240A.1"
#man5240A="fxpsdefault240A.5"

# GUI Tool
bins_gui="ufptool"
bins_gui5="ufptool5"
bins_gui7="ufptool7"
bins_gui_file=".UFPDefault"
resource_gui_file="Ufptool"

################################
## Printer Model Registration ##
################################
RegisterPrinterModels() {
    Model DC250     FXDC250.fd      "Document Centre 250/350/400"
    Model DC451     FXDC451.fd      "DocuCentre 450/550 CP"
    Model DC506      FXDC506.fd      "Document Centre 506/606/706"
    Model DC235      FXDC235.fd      "Document Centre 235/285/405"
    Model DP205      FXDP205.fd      "DocuPrint 205/255/305"
    Model DP240A     FXDP240A.fd     "DocuPrint 240A/340A"
    Model DC186      FXDC186.fd      "Document Centre 1085/1055/186/156"
    Model DC286      FXDC286.fd      "Document Centre 286/236"
    Model DC1100     FXDC1100.fd     "Document Centre 1100/900"
    Model DC336      FXDC336.fd      "Document Centre 336"
    Model AP550I     FXAP550I.fd     "ApeosPort 550 I/450 I/350 I"
    Model DC550I     FXDC550I.fd     "DocuCentre 550 I/450 I"
    Model AP750I     FXAP750I.fd     "ApeosPort 750 I/650 I"
    Model DC750I     FXDC750I.fd     "DocuCentre 750 I/650 I"
    Model DC23005    FXDC23005.fd    "DocuCentre-II 3005/2055/2005"
    Model AP24000    FXAP24000.fd    "ApeosPort-II 5010/4000/3000"
    Model DC24000    FXDC24000.fd    "DocuCentre-II 5010/4000"
    Model AP27000    FXAP27000.fd    "ApeosPort-II 7000/6000"
    Model DC27000    FXDC27000.fd    "DocuCentre-II 7000/6000"
    Model BinaryInstall205  dummy.fd        "Binary update only"
} #EndRegisterPrinterModels
# model_pt<n> ... printer model name
# model_fd<n> ... Solaris FD file name
# model_mn<n> ... menu string
Model() {
    [ x"$ModelCount" = x ] && ModelCount=0
    eval ModelCount=`expr $ModelCount + 1`
    eval model_pt$ModelCount=$1
    eval model_fd$ModelCount=$2
    eval model_mn$ModelCount="\"$3\""
    eval fd_$1=$2
}

## Display Model Selet Menu
ModelSelectMenu() {
    echo "Please wait..."
    RegisterPrinterModels
    clear
    echo "$progtitle" ;echo "$copyright" ;echo ""
    echo "Printer Model?"
    i=1; tmp=$i; menustr=x
    while [ x"$menustr" != xExit ]; do
        eval menustr="\"\$model_mn$i\""
        [ $i -gt $ModelCount ] && menustr="Exit"
        echo " ${i}. $menustr"
        [ $i -gt 1 ] && tmp="${tmp}/${i}"
        i=`expr $i + 1`
    done
    i=""; while [ "`expr $i + 0 2>&1`" != "$i" ]; do
        echo -n "Enter Process No(${tmp})?:"
        read i
    done
    if [ $i -gt $ModelCount ]; then
        exit;
    fi
    eval PrinterName=\$model_pt$i
    if [ "`P205check`" = "true" ]
    then
        PACKAGE=$PACKAGE205
        BINDIR=$BINDIR205
        LIBDIR=$LIBDIR205
        defaults=$defaults205
        ETCDIR=$ETCDIR205
#        man1=$man1205
#        man5=$man5205
    elif [ "`P240Acheck`" = "true" ]
    then
        PACKAGE=$PACKAGE240A
        BINDIR=$BINDIR240A
        LIBDIR=$LIBDIR240A
        defaults=$defaults240A
        ETCDIR=$ETCDIR240A
#        man1=$man1240A
#        man5=$man5240A
        bins=$bins240A
    fi
}

### mono205 Series Check ###
P205check() {
    if [ "${PrinterName}" = "DP205" ]
    then
        echo "true"     # DocuPrint 205 Series
    elif [ "${PrinterName}" = "DC186" ]
    then
        echo "true"     # Document Centre 1085/1055/186/156 Series
    elif [ "${PrinterName}" = "DC286" ]
    then
        echo "true"     # Document Centre 286/236 Series
    elif [ "${PrinterName}" = "DC1100" ]
    then
        echo "true"     # Document Centre 1100/900 Series
    elif [ "${PrinterName}" = "DC336" ]
    then
        echo "true"     # Document Centre 336 Series
    elif [ "${PrinterName}" = "AP550I" ]
    then
        echo "true"     # ApeosPort 550 I/450 I/350 I Series
    elif [ "${PrinterName}" = "DC550I" ]
    then
        echo "true"     # DocuCentre 550 I/450 I Series
    elif [ "${PrinterName}" = "AP750I" ]
    then
        echo "true"     # ApeosPort 750 I/650 I Series
    elif [ "${PrinterName}" = "DC750I" ]
    then
        echo "true"     # DocuCentre 750 I/650 I Series
    elif [ "${PrinterName}" = "DC23005" ]
    then
        echo "true"     # DocuCentre-II 3005/2055/2005 Series
    elif [ "${PrinterName}" = "AP24000" ]
    then
        echo "true"     # ApeosPort-II 5010/4000/3000 Series
    elif [ "${PrinterName}" = "DC24000" ]
    then
        echo "true"     # DocuCentre-II 5010/4000 Series
    elif [ "${PrinterName}" = "AP27000" ]
    then
        echo "true"     # ApeosPort-II 7000/6000 Series
    elif [ "${PrinterName}" = "DC27000" ]
    then
        echo "true"     # DocuCentre-II 7000/6000 Series
    elif [ "${PrinterName}" = "BinaryInstall205" ]
    then
        echo "true"     # BinaryInstall
    else
        echo "false"    # Not DocuPrint 205 Series
    fi
}

################################
### DocuPrint 240A Series Check ###
P240Acheck() {
    if [ "${PrinterName}" = "DP240A" ]
    then
        echo "true"     # DocuPrint 240A Series
    else
        echo "false"    # Not DocuPrint 240A Series
    fi
}

################################
# Local functions
#
### turn off MSI/MailBox/Sorter
CutOff() {
    egrep -v 'MSI|m1|m2|m3|m4|m5|m6|m7|m8|m9|m10|Ost' $1
}

### get OS Major Version ###
OSMVersion() {
    uname -r | awk '{printf ("%s",substr($1,1,1))}'
}

### get OS Version ###
OSVersion() {
    uname -r | awk '{printf ("%s",substr($1,1,3))}'
}

### nlecho message ###
nlecho() {
    echo ; echo $*
}

### errorexit exitcode message ###
errorexit() {
    nlecho "$progname:$2" 1>&2
    ${EJECT}
    echo ; exit $1
}

### readparam message default_value
readparam() {
    if [ "$2" = "" ]; then
        echo ; echo -n "$1:"
        read parameter
    else
        echo ; echo -n "$1[$2]:"
        read parameter
        parameter="${parameter:-$2}"
    fi
}

### readenum message default_value
readenum() {
    parameter=""
    while [ "${parameter}" = "" ]; do
        echo ; echo -n "$1(1:$2 2:$3):"
        read parameter
        if [ "${parameter}" = "1" ]; then
            parameter="$2"
        elif [ "${parameter}" = "2" ]; then
            parameter="$3"
        else
            parameter=""
        fi
    done
}

### ask 'y' or 'n' ###
YesNo() {
    ans=""
    case "$2" in
    Yes|y) dmsg="y";;
    No|n)  dmsg="n";;
    *)   dmsg="";;
    esac
    while [ "$ans" = "" ]; do
        echo ; echo -n "$1(y/n)${dmsg:+[$dmsg]}:"
        read ans
        ans="${ans:-$dmsg}"
        if [ "$ans" = "y" -o "$ans" = "n" ]; then return ; fi
        echo "You must select 'y' or 'n'."
        ans=""
    done
}

### Menu ###
Menu() {
    n=$#; i=1; tmp=$i
    while [ $i -le $n ]; do
        echo " ${i}. $1"
        if [ $i -gt 1 ]; then
            tmp="${tmp}/${i}"
        fi
        eval param_$i="\"$1\""
        shift; i=`expr $i + 1`
    done
    i=""; while [ "`expr $i + 0 2>&1`" != "$i" ]; do
        echo -n "Enter Process No(${tmp})?:"
        read i
    done
    eval ans=\$param_"$i"
    return $i
}

### Extract ###
Extract() {
    install_directory=$1
    shift 1
    install_Zfiles=""
    install_files=""
    for f in $*; do
        install_Zfiles="${install_Zfiles} $f.Z"
        install_files="${install_files} $f"
    done
    ${REWIND}
    cwd=`pwd`
    cd ${CURDIR}
    tar xvf ${TAPEDEV} ${install_Zfiles}
    for f in ${install_files}; do
        uncompress ${f}
        install -g bin -o root $f ${install_directory}
        /bin/rm ${CURDIR}/$f
    done
    cd $cwd
}

### filename ###
filename() {
    set `echo $1 | sed 's/\// /g'`
    shift `expr $# - 1`
    echo $1
}

### found ###
found() {
    for i in $1; do
        if [ "${i}" = $2 ]; then
            return 0
        fi
    done
    return 1
}

### keyedit edit_file key addfile saved ###
keyedit() {
    echo -n " $1 ... "
    RC=255
    grep "$2" $1 >/dev/null 2>&1
    case "$?" in
        0) echo "already edited.";;
        2) echo "file not found.";;
        1) if [ ! -f "$4/`filename $1`" ]; then
                cp $1 $4
                RC=0
            fi
            if [ -w $1 ]; then
                cat $3 >> $1 2>/dev/null
                echo "done"
            else
                echo "Permission denied."
            fi
        ;;
    esac
    return ${RC}
}

### read parameter with confirm ###
ReadParamWithConfirm() {
    parameter=""
    while [ "${parameter}" = "" ]; do
        readparam "Enter $1?" "$2"
        if [ "$#" = "2" ]; then
            YesNo "$1 is '${parameter}'" "y"
            if [ "$ans" = "n" ]; then
                parameter=""
            fi
        elif [ $3 ${parameter} ]; then
            parameter=""
        fi
    done
}

### read printer name with confirm ###
ReadPrinterNameWithConfirm() {
    parameter=""
    while [ "${parameter}" = "" ]; do
        readparam "Enter $1?" "$2"
        if (echo ${parameter} | grep "[^a-zA-Z0-9_]"); then
            echo "$1 can contain alphanumeric characters and underscores"
            parameter=""
        else
            if [ "`echo -n ${parameter} | wc -c`" -le 14 ]; then
                YesNo "$1 is '${parameter}'" "y"
                if [ "$ans" = "n" ]; then
                    parameter=""
                fi
            else
                echo "$1 exceeds 14 character"
                parameter=""
            fi
        fi
    done
}

### Extract Setting PS file for Laser Press 2100PS (s.okochi) ###
Extract2100PS() {
    install -d -m 755 ${BINDIR}/sample/2100PS
    cwd=`pwd`
    cd ${BINDIR}/sample/2100PS
    Extract ${BINDIR}/sample/2100PS ${samples2100}
    tar xvf ${BINDIR}/sample/2100PS/${samples2100}
    rm -f ${BINDIR}/sample/2100PS/${samples2100}
    cd $cwd
}

mk_LIBDIR() {
    ### disk free space check
    df ; echo
    echo "This Software may be used 20MB disk space."
    echo "Enter library installation directory,if you want change."
    LINKDIR=""
    OK="n"
    while [ "${LINKDIR}" = "" ]; do
        while [ "${OK}" = "n" ]; do
            readparam "Enter directory name" "${LIBDIR}"
            if [ `expr substr ${parameter} 1 1` != "/" ]; then
                YesNo "directory is '`pwd`/${parameter}'  " n
            else
                YesNo "directory is '${parameter}'  " n
            fi
            OK=${ans}
        done
        LINKDIR="${parameter}"
        if [ -d ${LINKDIR} ];then
            echo "'${LINKDIR}' already exists."
            YesNo "Erase ${libs} ${defaults} in '${LINKDIR}'. Confirm?" n
            if [ "$ans" = "y" ];then
                dir=`pwd`
                echo -n "'delete..."
                cd ${LINKDIR}; rm -rf ${libs} UserDefault/${defaults}
                cd ${dir}
                echo "done"
            fi
        fi
    done
    if [ "${LINKDIR}" != "${LIBDIR}" ];then
        mkdir ${LINKDIR}
        ln -s ${LINKDIR} ${LIBDIR}
    else
        [ ! -d $LIBDIR ] && mkdir $LIBDIR
    fi
    set `df ${LIBDIR} | grep -v Filesystem`
    FREE="$4" ; FILESYS="$6"
    if [ ${FREE:=0} -lt 1024 ]; then
        nlecho "Not enough space in '${FILESYS}' file system."
        rm -rf ${LIBDIR} ${LINKDIR}
        errorexit 255 "Installation give up."
    fi
}

#Make binary install directry
mk_BINDIR() {
    LINKBDIR=""
    WORKPARAM=""
    OK="n"
    while [ "${LINKBDIR}" = "" ]; do
        while [ "${OK}" = "n" ]; do
            readparam "Enter binary directory name" "${BINDIR}"
            if [ `expr substr ${parameter} 1 1` != "/" ]; then
                YesNo "directory is '`pwd`/${parameter}'  " n
                WORKPARAM="`pwd`/${parameter}"
            else
                YesNo "directory is '${parameter}'  " n
                WORKPARAM="${parameter}"
            fi
            OK=${ans}
        done
        LINKBDIR="${WORKPARAM}"
        if [ -d ${LINKBDIR} ];then
            echo "'${LINKBDIR}' already exists."
            YesNo "Erase ${bins} ${bins_gui} in '${LINKBDIR}'. Confirm?" n
            if [ "$ans" = "y" ];then
                dir=`pwd`
                echo -n "'delete..."
                cd ${LINKBDIR}; rm -rf ${bins}
                rm -rf ${bins_gui}
                cd ${dir}
                echo "done"
            fi
        fi
        if [ -d ${LINKBDIR}/UFPDefault ];then
            echo "'${LINKBDIR}/UFPDefault' already exists."
            YesNo "Erase ${bins_gui_file} in '${LINKBDIR}/UFPDefault'.Confirm?" n
            if [ "$ans" = "y" ];then
                dir=`pwd`
                echo -n "'delete..."
                cd ${LINKBDIR}; rm -rf ${bins_gui_file}
                cd ${dir}
                echo "done"
            fi
        fi
    done
    if [ "${LINKBDIR}" != "${BINDIR}" ];then
        mkdir ${LINKBDIR}
        BINDIR="${LINKBDIR}"
    else
        [ ! -d $BINDIR ] && mkdir $BINDIR
    fi
    set `df ${BINDIR} | grep -v Filesystem`
    FREE="$4" ; FILESYS="$6"
    if [ ${FREE:=0} -lt 5120 ]; then
        nlecho "Not enough space in '${FILESYS}' file system."
        rm -rf ${LINKBDIR}
        errorexit 255 "Installation give up."
    fi
}

#Clean library install directory for binary update
mk_UD_LIBDIR() {
    ### disk free space check
    echo "Enter library and binary installed directory."
    LINKDIR=""
    OK="n"
    while [ "${LINKDIR}" = "" ]
    do
        while [ "${OK}" = "n" ]
        do
            readparam "Enter library directory name" "${LIBDIR}"
            if [ `expr substr ${parameter} 1 1` != "/" ]
            then
                YesNo "directory is '`pwd`/${parameter}'  " n
            else
                YesNo "directory is '${parameter}'  " n
            fi
            OK=${ans}
        done
        LINKDIR="${parameter}"
        if [ -d ${LINKDIR} ]
        then
            dir=`pwd`
            echo -n "'Delete all old library files..."
            cd ${LINKDIR}
            rm -rf ${libs}
            cd ${dir}
            echo "done"
        else
            echo "Directory not found."
            echo "Binary update give up."
            exit 255
        fi
    done
}

#Clean binary install directory for binary update
mk_UD_BINDIR() {
    LINKBDIR=""
    WORKPARAM=""
    OK="n"
    while [ "${LINKBDIR}" = "" ]
    do
        while [ "${OK}" = "n" ]
        do
            readparam "Enter binary directory name" "${BINDIR}"
            if [ `expr substr ${parameter} 1 1` != "/" ]
            then
                YesNo "directory is '`pwd`/${parameter}'  " n
                WORKPARAM="`pwd`/${parameter}"
            else
                YesNo "directory is '${parameter}'  " n
                WORKPARAM="${parameter}"
            fi
            OK=${ans}
        done
        LINKBDIR="${WORKPARAM}"
        if [ -d ${LINKBDIR} ]
        then
            dir=`pwd`
            echo -n "'Delete all old binary files..."
            cd ${LINKBDIR}
            rm -rf ${bins}
            rm -rf ${bins_gui}
            cd ${dir}
        else
            echo "Directory not found."
            echo "Binary update give up."
            exit 255
        fi
        if [ -d ${LINKBDIR}/UFPDefault ]
        then
            dir=`pwd`
            cd ${LINKBDIR}
            rm -rf ${bins_gui_file}
            cd ${dir}
            echo "done"
        fi
    done
}

#Make etc install directry
mk_ETCDIR() {
    LINKEDIR=""
    OK="n"
    while [ "${LINKEDIR}" = "" ]; do
        while [ "${OK}" = "n" ]; do
            readparam "Enter etc directory name" "${ETCDIR}"
            if [ `expr substr ${parameter} 1 1` != "/" ]; then
                YesNo "directory is '`pwd`/${parameter}'  " n
            else
                YesNo "directory is '${parameter}'  " n
            fi
            OK=${ans}
        done
        LINKEDIR="${parameter}"
        if [ -d ${LINKEDIR} ];then
            echo "'${LINKEDIR}' already exists."
            YesNo "Erase ${printcap} in '${LINKEDIR}'. Confirm?" n
            if [ "$ans" = "y" ];then
                dir=`pwd`
                echo -n "'delete..."
                cd ${LINKEDIR}; rm -rf ${printcap}
                cd ${dir}
                echo "done"
            fi
        fi
    done
    if [ "${LINKEDIR}" != "${ETCDIR}" ];then
        mkdir ${LINKEDIR}
        ETCDIR="${LINKEDIR}"
    else
        [ ! -d $ETCDIR ] && mkdir $ETCDIR
    fi
    set `df ${ETCDIR} | grep -v Filesystem`
    FREE="$4" ; FILESYS="$6"
    if [ ${FREE:=0} -lt 1000 ]; then
        nlecho "Not enough space in '${FILESYS}' file system."
        rm -rf ${LINKEDIR}
        errorexit 255 "Installation give up."
    fi
}

### do symbolic link ###
LN_S() {
    [ -f $2 ] && rm -f $2   # remove, if $2 already exists.
    ln -s $1 $2
}

### do hard link ###
LN_H() {
    [ -f $2 ] && rm -f $2   # remove, if $2 already exists.
    ln $1 $2
}

### Linux Install ###
Linux_Install() {
    YesNo "Install Filters?" "y"
    if [ "$ans" = "y" ]; then
        mk_LIBDIR
        mk_BINDIR
        mk_ETCDIR
        install -d -m 755 ${BINDIR}
        install -d -m 755 ${BINDIR}/UFPDefault
        install -d -m 755 ${LIBDIR}
        install -d -m 755 ${LIBDIR}/UserDefault
        install -d -m 755 ${ETCDIR}
        Extract ${LIBDIR} ${libs}
        Extract ${LIBDIR}/UserDefault ${defaults}
        Extract ${BINDIR} ${bins}
        RVER=`uname -r | awk '{printf ("%s",substr($1,5,2))}'`
        MVER=`uname -r | awk '{printf ("%s",substr($1,3,1))}'`
        eval MNUM=\$MVER
        eval RNUM=\$RVER
        # Kernel Ver 2.0.xx
        if [ 0 -eq $MNUM ]
        then
            # Kernel Ver 2.0.36 upper
            if [ 35 -lt $RNUM ]
            then
                tar xvf ${TAPEDEV} ${bins_gui5}.Z
                uncompress ${bins_gui5}.Z
                install -g bin -o root ${bins_gui5} ${BINDIR}/${bins_gui}
                /bin/rm ${CURDIR}/${bins_gui5}
            else
                Extract ${BINDIR} ${bins_gui}
            fi
        # Kernel Ver 2.2.xx
        elif [ 2 -eq $MNUM ]
        then
            GMVER=`rpm -q glibc | awk '{printf ("%s",substr($1,9,1))}'`
            GRVERT=`rpm -q glibc | awk '{printf ("%s",substr($1,12,1))}'`
            if [ "-" == $GRVERT ]
            then
                GRVER=`rpm -q glibc | awk '{printf ("%s",substr($1,11,1))}'`
            else
                GRVER=`rpm -q glibc | awk '{printf ("%s",substr($1,11,2))}'`
            fi
            eval GMNUM=\$GMVER
            eval GRNUM=\$GRVER
            # glibc Ver 2.2.xx
            if [ 2 -eq $GMNUM ]
            then
                tar xvf ${TAPEDEV} ${bins_gui7}.Z
                uncompress ${bins_gui7}.Z
                install -g bin -o root ${bins_gui7} ${BINDIR}/${bins_gui}
                rm ${CURDIR}/${bins_gui7}
            # glibc Ver 2.1.95 upper
            elif [ 94 -lt $GRNUM ]
            then
                tar xvf ${TAPEDEV} ${bins_gui7}.Z
                uncompress ${bins_gui7}.Z
                install -g bin -o root ${bins_gui7} ${BINDIR}/${bins_gui}
                rm ${CURDIR}/${bins_gui7}
            else
                tar xvf ${TAPEDEV} ${bins_gui5}.Z
                uncompress ${bins_gui5}.Z
                install -g bin -o root ${bins_gui5} ${BINDIR}/${bins_gui}
                /bin/rm ${CURDIR}/${bins_gui5}
            fi
        # Kernel Ver 2.x.xx
        else
            GMVER=`rpm -q glibc | awk '{printf ("%s",substr($1,9,1))}'`
            eval GMNUM=\$GMVER
            # glibc Ver 2.1.xx
            if [ 1 -eq $GMNUM ]
            then
                tar xvf ${TAPEDEV} ${bins_gui5}.Z
                uncompress ${bins_gui5}.Z
                install -g bin -o root ${bins_gui5} ${BINDIR}/${bins_gui}
                /bin/rm ${CURDIR}/${bins_gui5}
            # glibc Ver 2.2.xx upper
            else
                tar xvf ${TAPEDEV} ${bins_gui7}.Z
                uncompress ${bins_gui7}.Z
                install -g bin -o root ${bins_gui7} ${BINDIR}/${bins_gui}
                rm ${CURDIR}/${bins_gui7}
            fi
        fi
        Extract ${BINDIR}/UFPDefault ${bins_gui_file}
        Extract ${RESOURCEDIR} ${resource_gui_file}
        if [ "$PrinterName" = "LaserPress2100" ]; then # s.okochi
            Extract2100PS ${BINDIR}/sample
            Extract ${ETCDIR} ${printcap2100}
            printcap="${printcap2100}"
        else
            Extract ${ETCDIR} ${printcap}
        fi
##        if [ -d ${MANDIRF} ]; then
##            MANDIR="${MANDIRF}"
##        elif [ -d ${MANDIR2} ]; then
##            LN_S ${MANDIR2} ${MANDIR};
##        fi
##        Extract ${MANDIR}/man1 ${man1}
##        Extract ${MANDIR}/man5 ${man5}
##        if [ "`P205check`" = "true" ]
##        then
##            cd $MANDIR/man5
##            LN_S fxpsdefault205.5 .fxpsdefault205.5
##        else
##            cd $MANDIR/man5
##            LN_S fxpsdefault.5 .fxpsdefault.5
##        fi
        # do binary hard link
        if [ "`P240Acheck`" = "true" ]
        then
            # do binary hard link
            LN_H ${BINDIR}/txt2ps2 ${LIBDIR}/fxpif
        else
            LN_H ${BINDIR}/euc2ps2 ${LIBDIR}/fxpif
        fi
        LN_H ${BINDIR}/xwd2ps2 ${BINDIR}/xwd2g4
        LN_H ${BINDIR}/xwd2ps2 ${LIBDIR}/fxpvf
        LN_H ${BINDIR}/xwd2ps2 ${LIBDIR}/fxpg4f
        LN_H ${BINDIR}/tiff2ps2 ${BINDIR}/tiff2g4
        cd ${LIBDIR}; for i in ${filter_add}; do
            for j in ${filter}; do
                LN_S ${j} ${j}_${i};
            done;
        done
        echo "*** Editing ${PrinterName} Enviroment files. ***"
        echo
        if [ "`P205check`" = "true" ]
        then
            MTYPE="205"
        elif [ "`P240Acheck`" = "true" ]
        then
            MTYPE="240A"
        else
            MTYPE=""
        fi
        if keyedit ${PRINTCAP} fxps${MTYPE}/fxpif ${ETCDIR}/${printcap} ${SAVEDIR}
        then
            SAVE_FILES="${SAVE_FILES} ${PRINTCAP}"
        fi
        echo "${BINDIR}" > /tmp/fxbinpath${MTYPE}
        install -g bin -o root /tmp/fxbinpath${MTYPE} ${LIBDIR}
        rm -f /tmp/fxbinpath${MTYPE}
    fi
    echo
    if [ "${SAVE_FILES}" ]; then
        echo ${SAVE_FILES} | tr -s ' ' '\012'
        echo "Original files is saved in '${SAVEDIR}'."
    else
        rm -r ${SAVEDIR}
    fi
}

### Linux Binary Install ###
Linux_BinaryInstall() {
   YesNo "Update Binaries?" "y"
   if [ "$ans" = "y" ]
   then
       mk_UD_LIBDIR
       mk_UD_BINDIR
       install -d -m 755 ${BINDIR}
       install -d -m 755 ${BINDIR}/UFPDefault
       install -d -m 755 ${LIBDIR}
       Extract ${LIBDIR} ${libs}
       Extract ${BINDIR} ${bins}
       RVER=`uname -r | awk '{printf ("%s",substr($1,5,2))}'`
       MVER=`uname -r | awk '{printf ("%s",substr($1,3,1))}'`
       eval MNUM=\$MVER #MinerVersion
       eval RNUM=\$RVER #Revision
       #if Kernel Ver 2.0.xx
       if [ 0 -eq $MNUM ]
       then
           #if Kernel Ver 2.0.36 upper
           if [ 35 -lt $RNUM ]
           then
               tar xvf ${TAPEDEV} ${bins_gui5}.Z
               uncompress ${bins_gui5}.Z
               install -g bin -o root ${bins_gui5} ${BINDIR}/${bins_gui}
               /bin/rm ${CURDIR}/${bins_gui5}
           else
               Extract ${BINDIR} ${bins_gui}
           fi
       #if Kernel Ver 2.2.xx
       elif [ 2 -eq $MNUM ]
       then
           GMVER=`rpm -q glibc | awk '{printf ("%s",substr($1,9,1))}'`
           GRVERT=`rpm -q glibc | awk '{printf ("%s",substr($1,12,1))}'`
           if [ "-" == $GRVERT ]
           then
               GRVER=`rpm -q glibc | awk '{printf ("%s",substr($1,11,1))}'`
           else
               GRVER=`rpm -q glibc | awk '{printf ("%s",substr($1,11,2))}'`
           fi
           eval GMNUM=\$GMVER
           eval GRNUM=\$GRVER
           #if glibc Ver 2.2.xx
           if [ 2 -eq $GMNUM ]
           then
               tar xvf ${TAPEDEV} ${bins_gui7}.Z
               uncompress ${bins_gui7}.Z
               install -g bin -o root ${bins_gui7} ${BINDIR}/${bins_gui}
               rm ${CURDIR}/${bins_gui7}
           #if glibc Ver 2.1.95 upper
           elif [ 94 -lt $GRNUM ]
           then
               tar xvf ${TAPEDEV} ${bins_gui7}.Z
               uncompress ${bins_gui7}.Z
               install -g bin -o root ${bins_gui7} ${BINDIR}/${bins_gui}
               rm ${CURDIR}/${bins_gui7}
           else
               tar xvf ${TAPEDEV} ${bins_gui5}.Z
               uncompress ${bins_gui5}.Z
               install -g bin -o root ${bins_gui5} ${BINDIR}/${bins_gui}
               /bin/rm ${CURDIR}/${bins_gui5}
           fi
       #if Kernel Ver 2.x.xx
       else
           GMVER=`rpm -q glibc | awk '{printf ("%s",substr($1,9,1))}'`
           eval GMNUM=\$GMVER
           #if glibc Ver 2.1.xx
           if [ 1 -eq $GMNUM ]
           then
               tar xvf ${TAPEDEV} ${bins_gui5}.Z
               uncompress ${bins_gui5}.Z
               install -g bin -o root ${bins_gui5} ${BINDIR}/${bins_gui}
               /bin/rm ${CURDIR}/${bins_gui5}
           #if glibc Ver 2.2.xx upper
           else
               tar xvf ${TAPEDEV} ${bins_gui7}.Z
               uncompress ${bins_gui7}.Z
               install -g bin -o root ${bins_gui7} ${BINDIR}/${bins_gui}
               rm ${CURDIR}/${bins_gui7}
           fi
       fi
       Extract ${BINDIR}/UFPDefault ${bins_gui_file}
       Extract ${RESOURCEDIR} ${resource_gui_file}
##       if [ -d ${MANDIRF} ]
##       then
##           MANDIR="${MANDIRF}"
##       elif [ -d ${MANDIR2} ]
##       then
##           LN_S ${MANDIR2} ${MANDIR}
##       fi
##       Extract ${MANDIR}/man1 ${man1}
##       Extract ${MANDIR}/man5 ${man5}
       ## compatibility
##       if [ "`P205check`" = "true" ]
##       then
##           cd $MANDIR/man5
##           LN_S fxpsdefault205.5 .fxpsdefault205.5
##       else
##           cd $MANDIR/man5
##           LN_S fxpsdefault.5 .fxpsdefault.5
##       fi
       # do binary hard link
       if [ "`P240Acheck`" = "true" ]
       then
           # do binary hard link
           LN_H ${BINDIR}/txt2ps2 ${LIBDIR}/fxpif
       else
           LN_H ${BINDIR}/euc2ps2 ${LIBDIR}/fxpif
       fi
       LN_H ${BINDIR}/xwd2ps2 ${LIBDIR}/fxpvf
       LN_H ${BINDIR}/xwd2ps2 ${LIBDIR}/fxpg4f
       LN_H ${BINDIR}/xwd2ps2 ${BINDIR}/xwd2g4
       LN_H ${BINDIR}/tiff2ps2 ${BINDIR}/tiff2g4
       cd ${LIBDIR}
       for i in ${filter_add}
       do
           for j in ${filter}
           do
               LN_S ${j} ${j}_${i}
           done
       done
       if [ "`P205check`" = "true" ]
       then
           MTYPE="205"
       elif [ "`P240Acheck`" = "true" ]
       then
           MTYPE="240A"
       else
           MTYPE=""
       fi
       echo "${BINDIR}" > /tmp/fxbinpath${MTYPE}
       install -g bin -o root /tmp/fxbinpath${MTYPE} ${LIBDIR}
       rm -f /tmp/fxbinpath${MTYPE}
   fi
}

##
setup_tapedevice() {
    if [ $?PACKAGE ]
    then
        if [ -f $PACKAGE ]
        then
            TAPEDEV=$PACKAGE
        else
            echo
            echo "Extracting a package, please wait..."
            tar xf $TAPEDEV $PACKAGE 2>&1 >/dev/null
            [ -f $PACKAGE ] && TAPEDEV=$PACKAGE
        fi
    fi  # if no package found, old version of Unix Filter
}

### Linux Install for DP240A only ###
Linux_Install240A() {
        YesNo "Install DocuPrint 240A/340A Filters?" "y"
        echo
        df ; echo
        echo "This Software requires at least 20MB disk space."
        echo ""
        echo "It is advisable NOT to change the default installation path for DocuPrint 240A/340A."
        echo "Doing so may cause incorrect behaviour when using the UNIX Driver."
        if [ "$ans" = "y" ]; then
                mk_BINDIR
                install -d -m 755 ${BINDIR}
                Extract ${BINDIR} ${bins}
                LN_H ${BINDIR}/txt2ps2 ${BINDIR}/fxpif

                install -d -m 755 ${BINDIR}/UFPDefault

                RVER=`uname -r | awk '{printf ("%s",substr($1,5,2))}'`
                MVER=`uname -r | awk '{printf ("%s",substr($1,3,1))}'`
                eval MNUM=\$MVER
                eval RNUM=\$RVER
                if [ 0 -eq $MNUM ]      #if Kernel Ver 2.0.xx
                then
                if [ 35 -lt $RNUM ] #if Kernel Ver 2.0.36 upper
                then
                    tar xvf ${TAPEDEV} ${bins_gui5}.Z
                    uncompress ${bins_gui5}.Z
                    install -g bin -o root ${bins_gui5} ${BINDIR}/${bins_gui}
                    /bin/rm ${CURDIR}/${bins_gui5}
                else
                    Extract  ${BINDIR}      ${bins_gui}
                fi
                elif [ 2 -eq $MNUM ]        #if Kernel Ver 2.2.xx
                then
                    GMVER=`rpm -q glibc | awk '{printf ("%s",substr($1,9,1))}'`
                    GRVERT=`rpm -q glibc | awk '{printf ("%s",substr($1,12,1))}'`
                if [ "-" == $GRVERT ]
                then
                    GRVER=`rpm -q glibc | awk '{printf ("%s",substr($1,11,1))}'`
                else
                    GRVER=`rpm -q glibc | awk '{printf ("%s",substr($1,11,2))}'`

                fi
                eval GMNUM=\$GMVER
                eval GRNUM=\$GRVER
                if [ 2 -eq $GMNUM ] #if glibc Ver 2.2.xx
                then
                    tar xvf ${TAPEDEV} ${bins_gui7}.Z
                    uncompress ${bins_gui7}.Z
                    install -g bin -o root ${bins_gui7} ${BINDIR}/${bins_gui}
                    rm ${CURDIR}/${bins_gui7}
                elif [ 94 -lt $GRNUM ]  #if glibc Ver 2.1.95 upper
                then
                    tar xvf ${TAPEDEV} ${bins_gui7}.Z
                    uncompress ${bins_gui7}.Z
                    install -g bin -o root ${bins_gui7} ${BINDIR}/${bins_gui}
                    rm ${CURDIR}/${bins_gui7}
                else
                    tar xvf ${TAPEDEV} ${bins_gui5}.Z
                    uncompress ${bins_gui5}.Z
                    install -g bin -o root ${bins_gui5} ${BINDIR}/${bins_gui}
                    /bin/rm ${CURDIR}/${bins_gui5}
                fi
                else                #if Kernel Ver 2.x.xx
                    GMVER=`rpm -q glibc | awk '{printf ("%s",substr($1,9,1))}'`
                    eval GMNUM=\$GMVER
                if [ 1 -eq $GMNUM ] #if glibc Ver 2.1.xx
                then
                    tar xvf ${TAPEDEV} ${bins_gui5}.Z
                    uncompress ${bins_gui5}.Z
                    install -g bin -o root ${bins_gui5} ${BINDIR}/${bins_gui}
                    /bin/rm ${CURDIR}/${bins_gui5}
                else        #if glibc Ver 2.2.xx upper
                    tar xvf ${TAPEDEV} ${bins_gui7}.Z
                    uncompress ${bins_gui7}.Z
                    install -g bin -o root ${bins_gui7} ${BINDIR}/${bins_gui}
                    rm ${CURDIR}/${bins_gui7}
                fi
            fi
            Extract  ${BINDIR}/UFPDefault   ${bins_gui_file}
            Extract  ${RESOURCEDIR}     ${resource_gui_file}

            echo "${BINDIR}" > /tmp/fxbinpath240A
            install -g bin -o root /tmp/fxbinpath240A ${BINDIR}
            rm -f /tmp/fxbinpath240A


        fi
}

################################
# START Installation Here
################################
#/usr/ucb/clear
if [ "`whoami`" != "root" ]; then
    errorexit 255 "should be used by 'root'."
fi
if [ ! -d ${SAVEDIR} ]; then mkdir ${SAVEDIR} ; fi
SAVE_FILES=""
ModelSelectMenu
setup_tapedevice
if [ -f ${PRINTCAP} ]; then
    if [ ! "$PrinterName" = "BinaryInstall205" ]
    then
        if [ "`P240Acheck`" = "true" ]
        then
            Linux_Install240A
        else
            Linux_Install
        fi
    else
        Linux_BinaryInstall
    fi
else
    install -d ${ROOT}/etc
    Extract ${ROOT}/etc printcap.header
    cd /etc
    mv printcap.header printcap
    chmod 644 printcap
    if [ "`P240Acheck`" = "true" ]
    then
        Linux_Install240A
    else
        Linux_Install
    fi
fi
    if [ "`P240Acheck`" != "true" ]
    then
	awk -F : '{print $1 " " $6}' /etc/passwd > ${LIBDIR}/UserDefault/.userhomedir
	chmod 755 ${LIBDIR}/UserDefault/.userhomedir
    fi
##[ -f $PACKAGE ] && rm -f $PACKAGE
echo ""; echo "done."
##### END-OF-INSTALL #####
